

#include "RealMatrix.h"
#include "UIntMatrix.h"

namespace idl
{
	/* Fits a polya distribution to the data, and returns it in vector a.
	 * localHistMatrix = nSampleDistributions*nSimVals matrix.  Each row is a histogram.
	 * a = 1*nSimVals vector of polya parameters.
	 */
	void polyaFit(const UIntMatrix &localHistMatrix, RealMatrix &a);

	RealMatrix polyaLogProb(const RealMatrix &a, const UIntMatrix &localHistMatrix);
	RealMatrix gradient2(const RealMatrix &a, const UIntMatrix &localHistMatrix, const UIntMatrix &rowSums);
	RealMatrix hessian_times_gradient2(const RealMatrix &a, const UIntMatrix &localHistMatrix,
									   const UIntMatrix &rowSums, const RealMatrix &g,
									   const double lambda);

	
}

